"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var minio_1 = require("minio");
var path_1 = __importDefault(require("path"));
var sharp_1 = __importDefault(require("sharp"));
var defaultKeyCallback = function (_req, file) {
    var fileExt = path_1.default.extname(file.originalname);
    return "".concat(Date.now()).concat(fileExt);
};
var defaultGeneratorCallback = function (params) {
    return __assign(__assign({}, params.file), { transforms: params.transforms });
};
var defaultObjectMetaCallback = function (_req, _file, _transform) { return ({}); };
var MulterMinioSharpStorage = /** @class */ (function () {
    function MulterMinioSharpStorage(opts) {
        this._removeFile = function (_req, file, callback) {
            callback(null);
            // NOT YET IMPLEMENTED
            // this.minioClient.removeObject(this.bucket, file.filename, () => callback(null))
        };
        var _a = opts.withSharpMeta, withSharpMeta = _a === void 0 ? true : _a;
        this.opts = opts;
        this.key = opts.key;
        this.objectMeta = opts.objectMeta;
        this.withSharpMeta = withSharpMeta;
        this.generator = opts.generator;
        this.bucket = opts.bucket;
        this.transforms = opts.transforms;
        this.minioClient = new minio_1.Client(opts.clientOptions);
    }
    MulterMinioSharpStorage.prototype._handleFile = function (req, file, callback) {
        var _this = this;
        var t = this;
        function transformation() {
            return __awaiter(this, void 0, void 0, function () {
                var untransformed, res;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            untransformed = file.stream;
                            return [4 /*yield*/, Promise.all(t.transforms.map(function (transform) { return __awaiter(_this, void 0, void 0, function () {
                                    var keyFn, key, transformed, transformedMetadata, objectMetaFn, objectMeta;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0:
                                                keyFn = transform.key || t.key || defaultKeyCallback;
                                                key = keyFn(req, file, transform);
                                                transformed = untransformed.pipe(transform.sharp(req, file, transform)).pipe((0, sharp_1.default)());
                                                if (!t.withSharpMeta) return [3 /*break*/, 2];
                                                return [4 /*yield*/, transformed.metadata()];
                                            case 1:
                                                transformedMetadata = _a.sent();
                                                _a.label = 2;
                                            case 2:
                                                objectMetaFn = transform.objectMeta || t.objectMeta || defaultObjectMetaCallback;
                                                objectMeta = objectMetaFn(req, file, transform);
                                                return [4 /*yield*/, t.minioClient
                                                        .putObject(t.bucket, key, transformed, objectMeta)
                                                        .then(function (objectInfo) {
                                                        transformed.destroy();
                                                        var res = {
                                                            id: transform.id,
                                                            status: 'success',
                                                            object: __assign(__assign({}, objectInfo), { key: key }),
                                                            meta: __assign({}, transformedMetadata)
                                                        };
                                                        return res;
                                                    })
                                                        // eslint-disable-next-line n/handle-callback-err
                                                        .catch(function (err) {
                                                        var res = {
                                                            id: transform.id,
                                                            status: 'error'
                                                        };
                                                        return res;
                                                    })];
                                            case 3: return [2 /*return*/, _a.sent()];
                                        }
                                    });
                                }); }))];
                        case 1:
                            res = _a.sent();
                            return [2 /*return*/, res];
                    }
                });
            });
        }
        transformation().then(function (transforms) {
            var generatorFn = _this.generator || defaultGeneratorCallback;
            var res = generatorFn({
                opts: _this.opts,
                file: file,
                transforms: transforms
            });
            callback(null, res);
        });
    };
    return MulterMinioSharpStorage;
}());
exports.default = MulterMinioSharpStorage;
